﻿--[[
    Author: darcey.lloyd@gmail.com
    
    Code Snippets:
    DTools.version();
    local DToolTestFrame = DTools.createTestFrame(200,200,"CENTER",0,0);

    TGA Export guide:
    8bit doesnt work
--]]
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local DMouse = {};
DMouse.version = "1.3.9";
DMouse.debug = false;
DMouse.offset = 0;
DMouse.mainContainer = null;
-- Unable to hide/show frame in combat move off screen via offset instead
DMouse.mainContainerXOffset = 0;
DMouse.offsetHide = 10000;
DMouse.texturePath = "Interface\\AddOns\\DMouse\\images\\";

DMouse.menu = {}
DMouse.menu.mainPage = nil;
DMouse.menu.page1 = nil;
DMouse.menu.page2 = nil;
DMouse.menu.page3 = nil;
DMouse.menu.page4 = nil;

DMouse.time = {}
DMouse.time.now = 99999999;
DMouse.time.prev = 0;
DMouse.time.updateFreq = 1000; -- Milliseconds 1000 = 1 sec

DMouse.EffectList = {};
DMouse.EffectList[1] = "Circles";
DMouse.EffectList[2] = "Target (Alpha)";
DMouse.EffectList[3] = "Fullscreen Crosshair";
DMouse.NoOfEffects = 3; -- LUA is so shait this is needed (or loop the table! wtf)

DMouse.modeReady = false; -- True when effect drawn and render function created

DMouse.circles = {};
DMouse.circles.frame1 = nil;
DMouse.circles.frame2 = nil;
DMouse.circles.frame3 = nil;
DMouse.circles.frame4 = nil;
DMouse.circles.scaleStep = 0.03;
DMouse.circles.scale1 = 0.2;
DMouse.circles.scale2 = 0.4;
DMouse.circles.scale3 = 0.6;
DMouse.circles.scale4 = 0.8;

DMouse.ef3 = {};
DMouse.ef3.frame1 = nil;
DMouse.ef3.frame2 = nil;
DMouse.ef3.scaleStep = 0.03;
DMouse.ef3.rotationSpeed = 10;
DMouse.ef3.frame1r = 0;
DMouse.ef3.scale2 = 0.4;

DMouse.ef4 = {};
DMouse.ef4.frame1 = nil;
DMouse.ef4.frame2 = nil;

DMouse["AnimFunction"] = nil;
DMouse["AlignFunction"] = nil;


-- Working vars
local tx = 0;
local ty = 0;
local uiScale = UIParent:GetEffectiveScale();
local resX = GetScreenWidth();
local resY = GetScreenHeight();
local screenW = resX * uiScale;
local screenH = resY * uiScale;
local xDif = resX - screenW;
local yDif = resY - screenH;

local scrWidthStep = 100 / screenW;
local scrHeightStep = 100 / screenH;
local xp = 0;
local resWidthStep = resX / 100;
local yp = 0;
local resHeightStep = resY / 100;

local mainContainerSize = 64;
local innerContainerSize = 64;

local t = 0;
local t1 = 0.2;
local t2 = 0.4;
local t3 = 0.6;
local t4 = 0.8;

local updateDelay = 0.3;
local scaleStep = 0.03;
local alphaOffset = 0;

local xOffset = 0 - (mainContainerSize/2);
local yOffset = 0 - (mainContainerSize/2);

local inCombat = false;
local alwaysOn = false;

local originalScale = 1;
local scale = 1;

DMouseRunOnce = false;
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initPresistentVars()
    -- Presistent variables
    if ( not DMouseDB ) then 
        DMouseDB = {};
    end

    if (DMouseDB["ShowWhenInCombatOnly"] == nil) then
        DMouseDB["ShowWhenInCombatOnly"] = true;
    end

    if (DMouseDB["HideWhenInVehicle"] == nil) then
        DMouseDB["HideWhenInVehicle"] = true;
    end

    if (DMouseDB["UserXOffset"] == nil) then
        DMouseDB["UserXOffset"] = 0;
    end

    if (DMouseDB["UserYOffset"] == nil) then
        DMouseDB["UserYOffset"] = 0;
    end

    if (DMouseDB["UpdateFrequency"] == nil) then
        DMouseDB["UpdateFrequency"] = 0.05; -- Milliseconds
    end

    if (DMouseDB["SelectedEffectIndex"] == nil) then
        DMouseDB["SelectedEffectIndex"] = 1;
    end

    if (DMouseDB["MainFrameOpacity"] == nil) then
        DMouseDB["MainFrameOpacity"] = 1;
    end


    -- Effect 1 options (Circles)
    if (DMouseDB["Effect1EnableFade"] == nil) then
        DMouseDB["Effect1EnableFade"] = true;
    end

    if (DMouseDB["Effect1ScaleLimit"] == nil) then
        DMouseDB["Effect1ScaleLimit"] = 1;
    end

    if (DMouseDB["Effect1FixFadeForScale"] == nil) then
        DMouseDB["Effect1FixFadeForScale"] = true;
    end

    -- Effect 2 options (Target Circle)



    -- Effect 3 options (Fullscreen Crosshair)
    if (DMouseDB["Effect3CrosshairSize"] == nil) then
        DMouseDB["Effect3CrosshairSize"] = 2;
    end

    if (DMouseDB["Effect3CrosshairR"] == nil) then
        DMouseDB["Effect3CrosshairR"] = 1;
    end

    if (DMouseDB["Effect3CrosshairG"] == nil) then
        DMouseDB["Effect3CrosshairG"] = 1;
    end

    if (DMouseDB["Effect3CrosshairB"] == nil) then
        DMouseDB["Effect3CrosshairB"] = 1;
    end

    if (DMouseDB["Effect3CrosshairA"] == nil) then
        DMouseDB["Effect3CrosshairA"] = 0.3;
    end

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #












-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseInit()
    -- Persistent var init
    initPresistentVars();

    -- Set main frame opacity (has to be done here DMouseDB not available on frame creation)
    DMouse.mainContainer:SetAlpha(DMouseDB["MainFrameOpacity"]);

    -- |cttrrggbb
    -- |c -- Change text colour, don't change this unless your output doesn't change colour, then change the '|' to '\124' (ie: \124ff000000)
    -- tt -- first two bits control the text transparency, from 00 (invisible) to ff (opaque).
    -- rr -- second two bits control red colour
    -- gg -- third two bits control green
    -- bb -- last two bits control blue

    -- Welcome
    print(" ");
    if (DMouse.debug) then
        print("|cffff0000" .. "DMouse v" .. DMouse.version .. ": DEBUG MODE!" .. "|r");
    else
        print("|cffffff00" .. "DMouse v" .. DMouse.version .. ": Type /dm menu for options." .. "|r");
        print("|cffffcc00" .. "DMouse: Now has multiple effects to choose from, see options.");
    end

    -- Effect selection
    if (DMouseDB["SelectedEffectIndex"] == 1) then
        DMouseSetupEffect1();
    elseif (DMouseDB["SelectedEffectIndex"] == 2) then
        DMouseSetupEffect2();
    elseif (DMouseDB["SelectedEffectIndex"] == 3) then
        DMouseSetupEffect3b();
    -- elseif (DMouseDB["SelectedEffectIndex"] == 4) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(0,0,0,1,32,31);
    -- elseif (DMouseDB["SelectedEffectIndex"] == 5) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(1,1,1,1,32,31);
    -- elseif (DMouseDB["SelectedEffectIndex"] == 6) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(0,0,0,2,31,31);
    -- elseif (DMouseDB["SelectedEffectIndex"] == 7) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(1,1,1,2,31,31);
    -- elseif (DMouseDB["SelectedEffectIndex"] == 8) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(0,0,0,3,31,30);
    -- elseif (DMouseDB["SelectedEffectIndex"] == 9) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(1,1,1,3,31,30);
    -- elseif (DMouseDB["SelectedEffectIndex"] == 10) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(1,1,1,5,30,29);
    -- elseif (DMouseDB["SelectedEffectIndex"] == 11) then
    --     -- DMouseSetupEffect4(r,g,b,size,xOffset,yOffset)
    --     DMouseSetupEffect4(1,1,1,5,30,29);
    -- else
    --     -- if this gets run you fucked up somewhere
    --     print("ERROR: Unknown mode / effect of [" .. DMouseDB["SelectedEffectIndex"] .. "]")
    --     return;
    end

    -- Setup addon menu
    DMouseSetupMenu();

    
    -- Get scale values
    scale = DMouse.mainContainer:GetEffectiveScale();
    originalScale = DMouse.mainContainer:GetEffectiveScale();
    -- print("DMouse scale = " .. scale);


    
    -- Setup slash commands
    SlashCmdList["DMouseCOMMAND"] = DMouseSlashCommandHandler;
    SLASH_DMouseCOMMAND1 = "/dm";
    
    -- initial state
    DMouse.mainContainer:Show();
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- MODE: Effect 1
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupEffect1()
    -- print("DMouse: DMouseSetupEffect1()");
    local textureW = 64;
    local textureH = 64;

    -- Circles 1 to 4
    DMouse.circles.frame1 = DMouseSetupEffect1CircleFrame("cBlack.tga",textureW,textureH);
    DMouse.circles.frame2 = DMouseSetupEffect1CircleFrame("cWhite.tga",textureW,textureH);
    DMouse.circles.frame3 = DMouseSetupEffect1CircleFrame("cBlack.tga",textureW,textureH);
    DMouse.circles.frame4 = DMouseSetupEffect1CircleFrame("cWhite.tga",textureW,textureH);

    DMouse["AnimFunction"] = function()
        local step = DMouse.circles.scaleStep;

        local alphaStep = 1 / DMouseDB["Effect1ScaleLimit"];
        local scaleLimit = DMouseDB["Effect1ScaleLimit"];


        DMouse.circles.scale1 = DMouse.circles.scale1 + step;
        if (DMouse.circles.scale1 >= scaleLimit) then
            DMouse.circles.scale1 = 0.01;
        end
        DMouse.circles.frame1:SetScale(DMouse.circles.scale1);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale1);
            else
                alpha = 1-DMouse.circles.scale1;
            end
            DMouse.circles.frame1:SetAlpha(alpha);
        else 
            DMouse.circles.frame1:SetAlpha(1);
        end
        
        
        
        DMouse.circles.scale2 = DMouse.circles.scale2 + step;
        if (DMouse.circles.scale2 >= scaleLimit) then
            DMouse.circles.scale2 = 0.01;
        end
        DMouse.circles.frame2:SetScale(DMouse.circles.scale2);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale2);
            else
                alpha = 1-DMouse.circles.scale2;
            end
            DMouse.circles.frame2:SetAlpha(alpha);
        else 
            DMouse.circles.frame2:SetAlpha(1);
        end
        
        
        DMouse.circles.scale3 = DMouse.circles.scale3 + scaleStep;
        if (DMouse.circles.scale3 >= scaleLimit) then
            DMouse.circles.scale3 = 0.01;
        end
        DMouse.circles.frame3:SetScale(DMouse.circles.scale3);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale3);
            else
                alpha = 1-DMouse.circles.scale3;
            end
            DMouse.circles.frame3:SetAlpha(alpha);
        else 
            DMouse.circles.frame3:SetAlpha(1);
        end
        
        
        DMouse.circles.scale4 = DMouse.circles.scale4 + scaleStep;
        if (DMouse.circles.scale4 >= scaleLimit) then
            DMouse.circles.scale4 = 0.01;
        end
        DMouse.circles.frame4:SetScale(DMouse.circles.scale4);
        if (DMouseDB["Effect1EnableFade"]) then
            local alpha = 0;
            if (DMouseDB["Effect1FixFadeForScale"]) then
                alpha = 1 - (alphaStep * DMouse.circles.scale4);
            else
                alpha = 1-DMouse.circles.scale4;
            end
            DMouse.circles.frame4:SetAlpha(alpha);
        else 
            DMouse.circles.frame4:SetAlpha(1);
        end
    
        
        
    end

    DMouse.modeReady = true;
end
-- # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupEffect1CircleFrame(textureName,w,h)
    local f = CreateFrame("Frame", "DMouseCircleFrame",DMouse.mainContainer)
    f:SetWidth(innerContainerSize)
    f:SetHeight(innerContainerSize)
    f:EnableMouse(false);

    local tex1 = f:CreateTexture(nil,"BACKGROUND")
    tex1:SetTexture("Interface\\AddOns\\DMouse\\images\\"..textureName)
    tex1:SetAllPoints(f)

    f.texture = tex1
    f:SetPoint("CENTER",0,0)
    f:Show()

    return f;
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- MODE: Effect 2
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupEffect2()
    -- print("DMouse: DMouseSetupEffect2()");

    -- Texture frames
    -- DTools.createTextureFrame(parent,texturePath,w,h)
    local f = DMouse.mainContainer;
    local path = DMouse.texturePath;
    DMouse.ef3.frame1 = DTools.createTextureFrame(f,path.."e2_part2_32b.tga",64,64);
    DMouse.ef3.frame1:SetScale(0.7);
    DMouse.ef3.frame1:SetAlpha(0.8);

    DMouse.ef3.frame2 = DTools.createTextureFrame(f,path.."cWhite.tga",64,64);

    DMouse["AnimFunction"] = function()
        DMouse.ef3.frame1.texture:SetRotation(degToRad(DMouse.ef3.frame1r))
        -- local rangeStep = 1 / 0.19
        -- local v = rangeStep * DMouseDB["UpdateFrequency"];
        -- local r = DMouse.ef3.rotationSpeed * v;
        -- print(r);
        DMouse.ef3.frame1r = DMouse.ef3.frame1r - DMouse.ef3.rotationSpeed;
        -- DMouse.ef3.frame1r:SetAlpha(0.85);

        if (DMouse.ef3.frame1r > 360) then
            DMouse.ef3.frame1r = 0;
        end

        local step = DMouse.circles.scaleStep;

        DMouse.circles.scale1 = DMouse.circles.scale1 + scaleStep;
        if (DMouse.circles.scale1 >= 1) then
            DMouse.circles.scale1 = 0.01;
        end
        DMouse.ef3.frame2:SetScale(DMouse.circles.scale1);
        DMouse.ef3.frame2:SetAlpha(1-DMouse.circles.scale1);
        
    end

    DMouse.modeReady = true;
end


-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- MODE: Effect 3
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupEffect3(r,g,b,size,yOffset,xOffset)
    -- print("DMouse: DMouseSetupEffect3()");

    -- Texture frames
    -- DTools.createTextureFrame(parent,texturePath,w,h)
    local f = DMouse.mainContainer;
    local path = DMouse.texturePath;

    -- horizontal line
	DMouse.ef4.frame1 = CreateFrame("Frame", "DME3Frame1", f)
	DMouse.ef4.frame1:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.frame1:SetWidth(6000)
	DMouse.ef4.frame1:SetHeight(size)
	DMouse.ef4.frame1:SetMovable(true);
	DMouse.ef4.frame1.texture = DMouse.ef4.frame1:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.frame1.texture:SetAllPoints(true)
	DMouse.ef4.frame1.texture:SetColorTexture(r,g,b, 0.5)
	DMouse.ef4.frame1:ClearAllPoints(true);
	DMouse.ef4.frame1:SetPoint("BOTTOMLEFT",-3000,xOffset);
	DMouse.ef4.frame1:EnableMouse(false);
    DMouse.ef4.frame1:SetMovable(true);
    
    -- vertical line
    DMouse.ef4.frame2 = CreateFrame("Frame", "DME3Frame1", f)
	DMouse.ef4.frame2:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.frame2:SetWidth(size)
	DMouse.ef4.frame2:SetHeight(6000)
	DMouse.ef4.frame2:SetMovable(true);
	DMouse.ef4.frame2.texture = DMouse.ef4.frame2:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.frame2.texture:SetAllPoints(true)
	DMouse.ef4.frame2.texture:SetColorTexture(r,g,b, 0.5)
	DMouse.ef4.frame2:ClearAllPoints(true);
	DMouse.ef4.frame2:SetPoint("BOTTOMLEFT",yOffset,-3000);
	DMouse.ef4.frame2:EnableMouse(false);
	DMouse.ef4.frame2:SetClampedToScreen(false);
	DMouse.ef4.frame2:SetMovable(true);

    -- Animation function
    DMouse["AnimFunction"] = function()
                
    end

    -- Animation function
    -- DMouse["AlignFunction"] = function()
    --     local uiScale, x, y = UIParent:GetEffectiveScale(), GetCursorPosition()

    --     xp = scrWidthStep * x;
    --     tx = resWidthStep * xp;
    --     tx = tx + xOffset;

    --     yp = scrHeightStep * y;
    --     ty = resHeightStep * yp;
    --     ty = ty + yOffset;

    --     tx = tx + DMouse.mainContainerXOffset + DMouseDB["UserXOffset"];
    --     ty = ty + DMouse.mainContainerXOffset + DMouseDB["UserYOffset"];

    --     DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
    --     DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
    --     DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
    --     DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
    -- end

    -- Flag effect is ready
    DMouse.modeReady = true;
end


function DMouseSetupEffect3b()
    -- print("DMouse: DMouseSetupEffect3()");

    local size = DMouseDB["Effect3CrosshairSize"];
    local r = DMouseDB["Effect3CrosshairR"];
    local g = DMouseDB["Effect3CrosshairG"];
    local b = DMouseDB["Effect3CrosshairB"];
    local a = DMouseDB["Effect3CrosshairA"];

    -- Texture frames
    -- DTools.createTextureFrame(parent,texturePath,w,h)
    local f = DMouse.mainContainer;

    -- horizontal line
	DMouse.ef4.frame1 = CreateFrame("Frame", "DME3Frame1", f)
	DMouse.ef4.frame1:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.frame1:SetWidth(6000)
	DMouse.ef4.frame1:SetHeight(size)
	DMouse.ef4.frame1:SetMovable(true);
	DMouse.ef4.frame1.texture = DMouse.ef4.frame1:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.frame1.texture:SetAllPoints(true)
	DMouse.ef4.frame1.texture:SetColorTexture(r,g,b, 0.5)
	DMouse.ef4.frame1:ClearAllPoints(true);
	DMouse.ef4.frame1:SetPoint("BOTTOMLEFT",-3000,0);
	DMouse.ef4.frame1:EnableMouse(false);
    DMouse.ef4.frame1:SetMovable(true);
    
    -- vertical line
    DMouse.ef4.frame2 = CreateFrame("Frame", "DME3Frame1", f)
	DMouse.ef4.frame2:SetFrameStrata("low"); -- background, low, medium, high, dialog, fullscreen, tooltip
	DMouse.ef4.frame2:SetWidth(size)
	DMouse.ef4.frame2:SetHeight(6000)
	DMouse.ef4.frame2:SetMovable(true);
	DMouse.ef4.frame2.texture = DMouse.ef4.frame2:CreateTexture(nil, "BACKGROUND")
	DMouse.ef4.frame2.texture:SetAllPoints(true)
	DMouse.ef4.frame2.texture:SetColorTexture(r,g,b, 0.5)
	DMouse.ef4.frame2:ClearAllPoints(true);
	DMouse.ef4.frame2:SetPoint("BOTTOMLEFT",0,-3000);
	DMouse.ef4.frame2:EnableMouse(false);
	DMouse.ef4.frame2:SetClampedToScreen(false);
	DMouse.ef4.frame2:SetMovable(true);

    -- Animation function
    DMouse["AnimFunction"] = function()
                
    end

    -- Animation function
    DMouse["AlignFunction"] = function()
        local uiScale, x, y = UIParent:GetEffectiveScale(), GetCursorPosition()

        -- Line Offsets based on thickness
        -- size 1 = 32,31
        -- size 5 = 30,29
        local size = DMouseDB["Effect3CrosshairSize"];
        local step = 2/30;
        local sizeOffset = size/2;

        xp = scrWidthStep * x;
        tx = resWidthStep * xp;
        tx = tx - sizeOffset

        yp = scrHeightStep * y;
        ty = resHeightStep * yp;
        ty = ty - sizeOffset;

        tx = tx + DMouse.mainContainerXOffset + DMouseDB["UserXOffset"];
        ty = ty + DMouse.mainContainerXOffset + DMouseDB["UserYOffset"];

        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
    end

    -- Flag effect is ready
    DMouse.modeReady = true;
end

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #












-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseAnimate(self)
    -- Check if mode has been setup and is ready for animation
    if (DMouse.modeReady == false) then
        return;
    end

    -- Handle combat only
    DMouse.mainContainerXOffset = DMouse.offsetHide;
    if (DMouseDB["ShowWhenInCombatOnly"]) then
        if (DTools.isInCombat()) then
            -- CombatOnly:1 & combat:1
            -- show
            DMouse.mainContainerXOffset = 0;
        else
            -- CombatOnly:1 & combat:0
            -- hide
            DMouse.mainContainerXOffset = DMouse.offsetHide;
        end
    else
        -- Always show
        DMouse.mainContainerXOffset = 0;
    end

    
    -- Handle vehicle
    if (DTools.isInVehicle() and DMouseDB["DisableWhenInVehicle"]) then
        DMouse.mainContainerXOffset = DMouse.offsetHide;
    end


    -- Align the frame with the mouse
    alignToMouse();


    -- Check if it's time to update the animation
    DMouse.time.now = GetTime();
    local timeSinceLastUpdate = DMouse.time.now - DMouse.time.prev;
    if (timeSinceLastUpdate >= (DMouseDB["UpdateFrequency"])) then
        -- print("UPDATE: " .. DMouse.time.now);
        -- print("DTools.inCombat = " .. DTools.inCombat);
        -- print("DTools.inVehicle = " .. DTools.inVehicle);
        -- Animation function is dynamically set per each effect
        DMouse["AnimFunction"]();
        DMouse.time.prev = DMouse.time.now;
    end

    
    
    
    
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









-- AlignToMouse
local scaleChanged = false;
function alignToMouse(self)
    if (DMouse["AlignFunction"] ~= nil) then
        DMouse["AlignFunction"]();
    else
        -- check scale
        -- uiScale = UIParent:GetEffectiveScale();
        -- scale = DMouse.mainContainer:GetEffectiveScale();
        -- if (originalScale ~= scale) then
        --     originalScale  = scale;
        --     print("|cffff0000 DMouse: Has detected a UI scale change!");
        --     print("|cffff0000 DMouse: It is recommended you UI Reload to fix alignment!");
        --     print("|cffff0000 DMouse: Type /reload");
        -- end

        local x, y = GetCursorPosition();
        --print( "MX:" .. tostring(x) );
        --self.f:SetPoint("CENTER",x,y);
        --print(tostring(self.f));
        -- 100% = screenW, mouse is also based on this
        -- find % on x mouse is and find that % of resX
        -- local scrWidthStep = 100 / screenW; -- Moved out of function to improve performance
        xp = scrWidthStep * x;
        --local resWidthStep = resX / 100; -- Moved out of function to improve performance
        tx = resWidthStep * xp;
        tx = tx + xOffset;
        
        --local scrHeightStep = 100 / screenH; -- Moved out of function to improve performance
        yp = scrHeightStep * y;
        --local resHeightStep = resY / 100; -- Moved out of function to improve performance
        ty = resHeightStep * yp;
        ty = ty + yOffset;

        -- TRICK HIDE SHOW IN COMBAT USE OFFSET WHICH CHANGES IF IN COMBAT OR NOT
        tx = tx + DMouse.mainContainerXOffset + DMouseDB["UserXOffset"];
        ty = ty + DMouse.mainContainerXOffset + DMouseDB["UserYOffset"];
        
        -- DO NOT DELETE GOOD FOR DEBUG
        -- local msg = "" ..
        --             "MX:" .. tostring( DUtilsRoundTo(x,1) ) ..
        --             "   MY:" .. tostring( DUtilsRoundTo(y,1) ) ..
        --             "   scrW:" .. tostring( DUtilsRoundTo(screenW,1) ) .. 
        --             "   resX:" .. tostring( DUtilsRoundTo(resX,1) ) .. 
        --             "   xDif:" .. tostring( DUtilsRoundTo(xDif,1) ) ..
        --             "   tx:" .. tostring( DUtilsRoundTo(tx,1) ) ..
        --             "   ty:" .. tostring( DUtilsRoundTo(ty,1) )
        --             --"    tx:" .. tostring( DUtilsRoundTo(tx,1) ) .. "    ty:" .. tostring( DUtilsRoundTo(ty,1) )
        -- print( msg );

        --print( "tx:" .. tostring( DUtilsRoundTo(tx,1) ) .. "    ty:" .. tostring( DUtilsRoundTo(ty,1) ) );
        --print("----");
        
        --DMouse.mainContainer:ClearAllPoints();
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
        DMouse.mainContainer:SetPoint("BOTTOMLEFT",tx,ty);
    end
    
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupMenu()
    -- Main page
    -- DMouse.menu.mainPage = DTools.createTestFrame(400,400,"TOPLEFT",0,0); -- For visual without opening menu
    DMouse.menu.mainPage = CreateFrame( "Frame", "DMouseMenuPage", UIParent );
    DMouseSetupMenuMainPage();
    DMouseSetupMenuPage1();
    DMouseSetupMenuPage2();
    DMouseSetupMenuPage3();

    


    
    -- -- local page1 = DTools.createTestFrame(200,200,"TOPLEFT",0,0); -- For visual without opening menu
    -- local page1 = CreateFrame( "Frame", "DMouseMenuPage1", UIParent );
    -- DTools.createText(page1,"Page 1",24,x,-10)
    
    -- local page2 = CreateFrame( "Frame", "DMouseMenuPage2", UIParent );
    -- DTools.createText(page2,"Page 2",24,x,-10)
    


    local addonMenu = DTools.createAddonMenu(
        "DMouse",DMouseVersion,"darcey.lloyd@gmail.com",
        DMouse.menu.mainPage
    );



    addonMenu.addPage("Circles",DMouse.menu.page1);
    addonMenu.addPage("Target (Alpha)",DMouse.menu.page2);
    addonMenu.addPage("Fullscreen Crosshair",DMouse.menu.page3);
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Circles menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupMenuPage1()
    local x = 10;
    local y = -10;

    DMouse.menu.page1 = CreateFrame( "Frame", "DMouseMenuPage1", UIParent );
    DTools.createText(DMouse.menu.page1,"DMouse - Effect 1 Options",18,"LEFT",x,y,1,1,0)
    y = y - 40; -- estimate height of item


    -- Checkbox: Enable/Disable fade effect
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	local cb1ClickHandler = function(checked)
        DMouseDB["Effect1EnableFade"]  = checked;
    end
	local cb1 = DTools.createCheckbox(
        "cb1",DMouse.menu.page1,"Enable fade effect?",
        x,y,
        DMouseDB["Effect1EnableFade"],
        cb1ClickHandler
    )
    y = y - 50; -- estimate height of item



    -- Slider: xOffset
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s1ChangeHandler = function(val)
		DMouseDB["Effect1ScaleLimit"] = val;
    end
	local s1 = DTools.createSlider(
        DMouse.menu.page1,
        0.5,4,0.1,
        "Scale limit",
        DMouseDB["Effect1ScaleLimit"],
        200,
        1,
        x,y,
        s1ChangeHandler,
        true
    )
    y = y - 60; -- estimate height of item    



    -- Checkbox: Enable/Disable fix fade for scale
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	local cb2ClickHandler = function(checked)
        DMouseDB["Effect1FixFadeForScale"]  = checked;
    end
	local cb2 = DTools.createCheckbox(
        "cb2",DMouse.menu.page1,"Correct fade effect for scale?",
        x,y,
        DMouseDB["Effect1FixFadeForScale"],
        cb2ClickHandler
    )
    y = y - 50; -- estimate height of item    


end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Target menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupMenuPage2()
    local x = 10;
    local y = -10;

    DMouse.menu.page2 = CreateFrame( "Frame", "DMouseMenuPage2", UIParent );
    DTools.createText(DMouse.menu.page2,"DMouse - Effect 2 Options",18,"LEFT",x,y,1,1,0)
    y = y - 40; -- estimate height of item


    -- Warning for reset button
    local msg = "";
    msg = msg .. "This is an alpha preview effect, it may be modified or removed in future updates." .. "\n"
    DTools.createText(DMouse.menu.page2,msg,12,"LEFT",x,y,1,0,0)
    y = y - 14; -- estimate height of item
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #










-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Fullscreen crosshair menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupMenuPage3()
    local x = 10;
    local y = -10;
    local min,max,step = 0,1,0.1;

    DMouse.menu.page3 = CreateFrame( "Frame", "DMouseMenuPage1", UIParent );
    DTools.createText(DMouse.menu.page3,"DMouse - Effect 3 Options",18,"LEFT",x,y,1,1,0)
    y = y - 50; -- estimate height of item


    
    -- Slider: thickness
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s1ChangeHandler = function(val)
        DMouseDB["Effect3CrosshairSize"] = val;
        DMouse.ef4.frame1:SetWidth(6000)
        DMouse.ef4.frame1:SetHeight(val)
        
        DMouse.ef4.frame2:SetWidth(val)
        DMouse.ef4.frame2:SetHeight(6000)
    end
	local s1 = DTools.createSlider(
        DMouse.menu.page3,
        1,100,1,
        "Crosshair thickness",
        DMouseDB["Effect3CrosshairSize"],
        380,
        1,
        x,y,
        s1ChangeHandler,
        true
    )
    y = y - 60; -- estimate height of item    




    -- Sliders: r,g,b,a
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local sliderRedChangeHandler = function(val)
        DMouseDB["Effect3CrosshairR"] = val;
        DMouseEffect4SetColor();
    end
    min,max,step = 0,1,0.1;
	local sR = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Red",DMouseDB["Effect3CrosshairR"],
        80,1,
        10,y,
        sliderRedChangeHandler,true
    )

    local sliderGreenChangeHandler = function(val)
        DMouseDB["Effect3CrosshairG"] = val;
        DMouseEffect4SetColor();
    end
	local sG = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Green",DMouseDB["Effect3CrosshairG"],
        80,1,
        100,y,
        sliderGreenChangeHandler,true
    )

    local sliderBlueChangeHandler = function(val)
        DMouseDB["Effect3CrosshairB"] = val;
        DMouseEffect4SetColor();
    end
	local sB = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Blue",DMouseDB["Effect3CrosshairB"],
        80,1,
        190,y,
        sliderBlueChangeHandler,true
    )

    local sliderAlphaChangeHandler = function(val)
        DMouseDB["Effect3CrosshairA"] = val;
        DMouseEffect4SetColor();
    end
	local sA = DTools.createSlider(
        DMouse.menu.page3,
        min,max,step,
        "Alpha",DMouseDB["Effect3CrosshairA"],
        80,1,
        280,y,
        sliderAlphaChangeHandler,true
    )




    y = y - 60; -- estimate height of item    

end

function DMouseEffect4SetColor()
    local r = DMouseDB["Effect3CrosshairR"];
    local g = DMouseDB["Effect3CrosshairG"];
    local b = DMouseDB["Effect3CrosshairB"];
    local a = DMouseDB["Effect3CrosshairA"];

    DMouse.ef4.frame1.texture:SetColorTexture(r,g,b,a)
    DMouse.ef4.frame2.texture:SetColorTexture(r,g,b,a)
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #








-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Main page menu
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSetupMenuMainPage()
    local x = 10;
    local y = -10;


    -- Page title
    -- function(frame,label,fontSize,x,y,r,g,b,font)
    DTools.createText(DMouse.menu.mainPage,"DMouse v" .. DMouse.version,18,"LEFT",x,y,1,1,0)
    y = y - 40; -- estimate height of item


	-- Checkbox: Show in combat only
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	local cb1ClickHandler = function(checked)
        DMouseDB["ShowWhenInCombatOnly"]  = checked;
    end
	local cb1 = DTools.createCheckbox(
        "cb1",DMouse.menu.mainPage,"Show in combat only?",
        x,y,
        DMouseDB["ShowWhenInCombatOnly"],
        cb1ClickHandler
    )
    y = y - 30; -- estimate height of item


    -- Checkbox: Hide when in vehicle?
	-- DTools.createCheckbox = function(name,frame,label,x,y,checked,clickHandler,font,fontSize)
	local cb2ClickHandler = function(checked)
        DMouseDB["HideWhenInVehicle"]  = checked;
    end
	local cb2 = DTools.createCheckbox(
        "cb2",DMouse.menu.mainPage,"Hide when in vehicle?",
        x,y,
        DMouseDB["HideWhenInVehicle"],
        cb2ClickHandler
    )
    y = y - 40; -- estimate height of item


    -- Label for drop down
    DTools.createText(DMouse.menu.mainPage,"Effect choice:",12,"LEFT",x,y)
    y = y - 14; -- estimate height of item
    DTools.createText(DMouse.menu.mainPage,"NOTE: Each effect has its own configuration options page.",12,"LEFT",x,y,1,0.7,0)
    y = y - 14; -- estimate height of item

    -- WARNING: LUA Tables / Arrays start at index 1
    local selectedIndex = 1;
    local dd1ChangeHandler = function(index,value)
        -- print("dd1ChangeHandler(index:" .. index ..",value:"..value..")");
        DMouseDB["SelectedEffectIndex"] = index;
        ReloadUI();
    end

    -- function(frame,selectText,list,selectedIndex,width,x,y,onChangeHandler)
    local dd1 = DTools.createDropDown(
        DMouse.menu.mainPage,
        "",
        DMouse.EffectList,
        DMouseDB["SelectedEffectIndex"],
        200,x,y,
        dd1ChangeHandler
    )
    y = y - 30; -- estimate height of item

    -- Warning for drop down
    DTools.createText(DMouse.menu.mainPage,"NOTE: WILL CAUSE UI RELOAD",12,"LEFT",x,y,1,0,0)
    y = y - 45; -- estimate height of item



    -- Slider: xOffset
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
    local s1ChangeHandler = function(val)
		DMouseDB["UserXOffset"] = val;
    end
	local s1 = DTools.createSlider(
        DMouse.menu.mainPage,
        -100,100,0.1,
        "X Offset",
        DMouseDB["UserXOffset"],
        200,
        1,
        x,y,
        s1ChangeHandler,
        true
    )
    y = y - 60; -- estimate height of item

    -- Slider: yOffset
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
	local s2Changehandler = function(val)
		DMouseDB["UserYOffset"] = val;
    end
	local s2 = DTools.createSlider(
        DMouse.menu.mainPage,
        -100,100,0.1,
        "Y Offset",
        DMouseDB["UserYOffset"],
        200,
        1,
        x,y,
        s2Changehandler,
        true
    )
    y = y - 60; -- estimate height of item

    -- Slider: Update speed
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
	local s3Changehandler = function(val)
		DMouseDB["UpdateFrequency"] = val;
    end
	local s3 = DTools.createSlider(
        DMouse.menu.mainPage,
        0.01,0.2,0.01,
        "Update speed (MS)",
        DMouseDB["UpdateFrequency"],
        200,
        2,
        x,y,
        s3Changehandler,
        true
    )
    y = y - 60; -- estimate height of item

    -- Slider: Mainframe opacity
	-- function(frame,min,max,step,label,default,width,decimalPrecision,x,y,changeHandler,showEditBox)
	local s4Changehandler = function(val)
        DMouseDB["MainFrameOpacity"] = val;
        DMouse.mainContainer:SetAlpha(DMouseDB["MainFrameOpacity"]);
    end
	local s3 = DTools.createSlider(
        DMouse.menu.mainPage,
        0.01,1,0.01,
        "Global Transparency",
        DMouseDB["MainFrameOpacity"],
        200,
        2,
        x,y,
        s4Changehandler,
        true
    )
    y = y - 60; -- estimate height of item


    

   




    -- Button
    -- createButton(frame,label,width,x,y,clickHandler,fontSize);
	local btnResetClick = function()
        DMouseDB["ShowWhenInCombatOnly"] = true;
        DMouseDB["HideWhenInVehicle"] = true;
        DMouseDB["UserXOffset"] = 0;
        DMouseDB["UserYOffset"] = 0;
        DMouseDB["UpdateFrequency"] = 0.05;
        DMouseDB["SelectedEffectIndex"] = 1;

        DMouseDB["Effect1EnableFade"] = true;
        DMouseDB["Effect1ScaleLimit"] = 1;
        DMouseDB["Effect1FixFadeForScale"] = true;
        DMouseDB["Effect3CrosshairSize"] = 2;
        DMouseDB["Effect3CrosshairR"] = 1;
        DMouseDB["Effect3CrosshairG"] = 1;
        DMouseDB["Effect3CrosshairB"] = 1;
        DMouseDB["Effect3CrosshairA"] = 0.3;

        ReloadUI();
    end
    local btnReset = DTools.createButton(DMouse.menu.mainPage,"RESET",100,x,y,btnResetClick);
    y = y - 26; -- estimate height of item



    -- Warning for reset button
    DTools.createText(DMouse.menu.mainPage,"NOTE: WILL CAUSE UI RELOAD",12,"LEFT",x,y,1,0,0)
    y = y - 20; -- estimate height of item

    -- Warning for reset button
    local msg = "USAGE INFORMATION:" .. "\n"
    msg = msg .. "If you change your UI scale or screen settings you will need to reload your ui." .. "\n"
    msg = msg .. "You can do this by typing /reload" .. "\n"
    DTools.createText(DMouse.menu.mainPage,msg,12,"LEFT",x,y,1,0.6,0)
    y = y - 14; -- estimate height of item
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DMouseSlashCommandHandler(cmd)
    -- dmlog("DMouseSlashCommandHandler(): " .. cmd);

    -- Doing this forces sub list (pages) to be expanded
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.page1);
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.page1);
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.mainPage);
    InterfaceOptionsFrame_OpenToCategory(DMouse.menu.mainPage);

	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #









-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- DMouse
-- Ensure this is last as certain things will not be ready
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- Main frame setup
DMouse.mainContainer = CreateFrame("Frame", "DMouse", UIParent)
DMouse.mainContainer:SetFrameStrata("BACKGROUND");
--DMouse.mainContainer:SetFrameStrata("BACKGROUND")
DMouse.mainContainer:SetWidth(mainContainerSize)
DMouse.mainContainer:SetHeight(mainContainerSize)
DMouse.mainContainer:SetMovable(true);
if (DMouse.debug == true) then
    DTools.setFrameBackground(DMouse.mainContainer,0,0,0,0.5);
end
--DMouse.mainContainer:SetPoint("CENTER",0,0)
DMouse.mainContainer:Show();
DMouse.mainContainer:EnableMouse(false);
DMouse.mainContainer:RegisterEvent("VARIABLES_LOADED");
DMouse.mainContainer:SetScript("OnEvent", function(self,event,addonName)
    -- print("EVENT = " .. event);
    if (event == "VARIABLES_LOADED") then
        DMouseInit();
    end
end);
DMouse.mainContainer:SetScript("OnUpdate", DMouseAnimate );
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #